/* Tudor-Andrei Erghelegiu
 * 331CA
 * Audio Spectrum Analyser
*/


#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <string.h>

#include "lookup.h"

#define N 32

#include "lcd.h"

void adc_init();
uint16_t adc_read();
void TRANSFORM();
void timer1_init();


uint8_t lcd_buf1[16];
uint8_t lcd_buf2[16];
int32_t fx[N];
int32_t Fu[N/2][2];


int main() {

	uint8_t mag;
    int i;
    adc_init();
    lcd_init();
	lcd_contrast(0x40);
    _delay_ms(5000);
    timer1_init();
    while(1) {
        TCNT1 = 0;
        TIFR1 |= 1<<OCF1A;
        for(i=0;i<N;i++) {
            while((TIFR1 & (1<<OCF1A)) == 0);
            fx[i] = ((int16_t)adc_read());
            TIFR1 |= 1<<OCF1A;
        }
        TRANSFORM();
        /* TODO: afiseaza caractere speciale pe ecran (sub forma de coloane) */
        for(i = 0; i < N/2; i++) {
			lcd_goto_xy(1,1);
			printf("%d,%d\n", Fu[i][0], Fu[i][1]);
			_delay_ms(100);
        }
    }
	return 0;
}

void TRANSFORM()
{
    int16_t count,degree;
    uint8_t u,k;
    count = 0;
    for (u=0; u<N/2; u++) {
        for (k=0; k<N; k++) {
            degree = (uint16_t)pgm_read_byte_near(degree_lookup + count)*2;
            count++;
            Fu[u][0] +=  fx[k] * (int16_t)pgm_read_word_near(cos_lookup + degree);
            Fu[u][1] += -fx[k] * (int16_t)pgm_read_word_near(sin_lookup + degree);
        }
        Fu[u][0] /= N;
        Fu[u][0] /= 10000;
        Fu[u][1] /= N;
        Fu[u][1] /= 10000;
    }
}

void timer1_init()
{
    TCCR1B = (1<<WGM12)|(1<<CS10);
    OCR1A = 800;
}

void adc_init()
{
    ADMUX = 0b11000000;
    ADCSRA =0b10000010;
}

uint16_t adc_read()
{
    volatile uint16_t retl,reth;
    ADCSRA |= 1<<ADSC;
    while(!ADIF);
    ADCSRA |= 1<<ADIF;
    retl = ADCL;
    reth = ADCH;
    reth<<=8;
    reth|=retl;
    return reth;
}

